/*
 * Bounded buffer 
 * 
 */

public class BoundedBuffer extends Object {

  private Object[] buffer;
  private int size;

  private int front;
  private int rear;

  private Sema empty;
  private Sema full;

  private Object pt;
  private Object gt;

  /**
   * Constructs a BoundedBuffer
   * @param init
   */
  public BoundedBuffer(int init) {
    buffer = new Object[init];
    size = init;
    front = 0;
    rear = 0;
    empty = new Sema(init);
    full = new Sema(0);
    pt = new Object();
    gt = new Object();
  }


  /**
   * Test BoundedBuffer empty
   */
  public boolean empty() {
    return (front == rear);
  }


  /**
   * Put an object to the BoundedBuffer
   * @param v
   */
  public void put(Object v) {
    empty.P();
    synchronized (pt) {
      buffer[ rear ] = v; 
      rear++; if (rear >= size) rear -= size;
    }
    full.V();
  }

  /**
   * Get an object from the BoundedBuffer
   */
  public Object get() {
    Object v;
    full.P();
    synchronized (gt) {
      v = buffer[ front ]; 
      front++; if (front >= size) front -= size;
    }
    empty.V();
    return v;
  }
}
