/**
 * ExAppStream
 * An output stream class for writing console
 * output to an textarea.
 * (jdk 1.1)
 */

import java.applet.*;
import java.awt.*;
import java.io.*;

public class ExAppStream extends PrintWriter {
  Applet app;
  TextArea textarea;
  String nl;
  
  public ExAppStream(Applet a, TextArea t) {
    super((OutputStream)null);
    app = a;
    textarea = t;
    nl = System.getProperty("line.separator");
    if (nl == null) nl = "\n";
  }

  public synchronized void println() {
    if (textarea.getRows() > 100) textarea.setText("");
    textarea.append(nl);
  }

  public synchronized void println(String s) {
    if (textarea.getRows() > 100) textarea.setText("");
    textarea.append(s+nl);
    app.repaint();
  }

  public synchronized void print(String s) {
    if (textarea.getRows() > 100) textarea.setText("");
    textarea.append(s);
    app.repaint();
  }
}
