/**
 * ExConsApp
 * 
 * This program is an applet version of ExCons
 * (jdk 1.1)
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class ExConsApp extends Applet implements Runnable, ActionListener {
  // output console
  TextArea textarea;

  // start button
  Button startbutton;

  // clear button
  Button clearbutton;

  // message field
  TextField message;

  // simulation program
  ExCons ex_cons;

  // channel factory
  ChannelFactory chanfac = null;

  // output stream for the program
  ExAppStream ex_out;

  /*
   * Sets up the applet view
   */
  public void init() {
    textarea = new TextArea(20, 20);
    startbutton = new Button("Start");
    clearbutton = new Button("Clear");
    message = new TextField(20);

    startbutton.addActionListener(this);
    add(startbutton);
    clearbutton.addActionListener(this);
    add(clearbutton);
    add(message);
    add("South", textarea);
    if (chanfac == null) chanfac = new ChannelFactory();
  }

  /*
   * Starts the applet
   */
  public void start() {
    ex_cons = new ExCons();
    ex_out = new ExAppStream(this, textarea);
    message.setText("Click on start");
  }

  /*
   * Starts the simulation
   */
  public void run() {
    message.setText("Running...");
    ex_cons.work(ex_out, chanfac);
    message.setText("Finished");
  }

  /*
   * Handles the button events.
   */
  public void actionPerformed(ActionEvent event) {
    Object src = event.getSource();
    if (src == startbutton) {
      message.setText("Starting...");
      textarea.setText("");
      new Thread(this).start();
    }
    else if (src == clearbutton) {
      textarea.setText("");
    }
  }

}
