/**
 * Semaphore
 *
 */
public class Sema {
  private int init;
  private int s;
  private int del;

  /**
   * Constructs a default semaphore
   */
  public Sema() {
    this(0);
  }

  /**
   * Constructs a semaphore with the given upper limit value
   */
  public Sema(int i) {
    if (i >=0) { init = i; } else { init = 0; }
    s = init;
    del = 0;
  }

  /**
   * Finalizes this object
   */
  protected void finalize() throws Throwable {
    if (init != s) { 
        int x = s - init;
        System.out.println("sema: " + x + " pending operations."); 
    }
   super.finalize();
  }

  /**
   * Performs the P operation
   */
  public synchronized void P() {
    while (s <= 0) {
      del++;
      try {
	this.wait(); 
      } catch (InterruptedException e) {}
      del--;
    }
    s--;
  }

  /**
   * Performs the V operation
   */
  public synchronized void V() {
    s++;
    if (del > 0) {
      this.notify();
    }
  }
}
